<?php 

namespace Teknisa\ACL\Services;

use Teknisa\ACL\Util\InstanceProvider;

class Vendedor{
    
    public function checkVendedor ($row){
        
        $entityManager = InstanceProvider::getEntityManager();
        $connection = $entityManager->getConnection();
        
        $params = array(
            'CDOPERADOR' => $row['CDOPERADOR'],
            'CDVENDEDOR' => substr($row['CDOPERADOR'],-4),
            'NRORG'      => InstanceProvider::getLibEnvironment()->getCurrentOrganizationId(),
            'IDTPIJURVEN'  => 'O',
            'NRINSJURVEN'  => substr($row['CDOPERADOR'],-5),
            'NMRAZSOCVEN'  => $row['NMOPERADOR'],
            'NMFANVEN'     => $row['NMOPERADOR'],
            'CDFILIAL'     => isset($row['CDFILIAL']) ? $row['CDFILIAL'] : null,
            'CDCAIXA'      => isset($row['CDCAIXA']) ? $row['CDCAIXA'] : null
        );
        
        $adqVendedorOperador = $connection->fetchAll(self::adqVendedorOperador, $params);
        if(!count($adqVendedorOperador)){
            $connection->beginTransaction();
            try{
                $connection->executeQuery(self::insertVendedor,$params);
                $connection->commit();
            }catch(\Exception $e){
                $connection->rollBack();
                throw $e;
            }
        }
    }
    
    const adqVendedorOperador = "
        SELECT 1
      FROM VENDEDOR
     WHERE (CDOPERADOR = :CDOPERADOR OR CDVENDEDOR = :CDVENDEDOR) AND NRORG = :NRORG
    ";
    
    const insertVendedor = " 
        INSERT INTO VENDEDOR
   (CDVENDEDOR, IDTPIJURVEN, NRINSJURVEN, CDOPERADOR, NMRAZSOCVEN, NMFANVEN, CDFILIAL, CDCAIXA,NRORG)
    VALUES
   (:CDVENDEDOR, :IDTPIJURVEN, :NRINSJURVEN, :CDOPERADOR, :NMRAZSOCVEN, :NMFANVEN, :CDFILIAL, :CDCAIXA, :NRORG)
    ";
}